"""global failover

Revision ID: 6b17a5ab4ddc
Revises: a1b3d1ca97db
Create Date: 2017-12-29 00:34:23.486876

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl



# revision identifiers, used by Alembic.
revision = '6b17a5ab4ddc'
down_revision = 'a1b3d1ca97db'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint('origination_global_failover_from_sip_code_key', 'origination_global_failover', type_='unique')
    op.create_foreign_key(None, 'origination_global_failover', 'global_failover', ['from_sip_code'], ['id'], ondelete='CASCADE')
    op.drop_constraint('termination_global_failover_from_sip_code_key', 'termination_global_failover', type_='unique')
    op.create_foreign_key(None, 'termination_global_failover', 'global_failover', ['from_sip_code'], ['id'], ondelete='CASCADE')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'termination_global_failover', type_='foreignkey')
    op.create_unique_constraint('termination_global_failover_from_sip_code_key', 'termination_global_failover', ['from_sip_code'])
    op.drop_constraint(None, 'origination_global_failover', type_='foreignkey')
    op.create_unique_constraint('origination_global_failover_from_sip_code_key', 'origination_global_failover', ['from_sip_code'])
    # ### end Alembic commands ###
